Wt: Wt::Chart::WEquidistantGridData Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Wt::Chart::WEquidistantGridData Class Reference
Charts (Wt::Chart)

Class representing grid-based data for on a 3D chart. More...

`#include <WEquidistantGridData.h>`

Inheritance diagram for Wt::Chart::WEquidistantGridData:
[legend]

## Public Member Functions
| WEquidistantGridData (std::shared_ptr< WAbstractItemModel > model, double XMin, double deltaX, double YMin, double deltaY)
| Constructor.
virtual double | minimum (Axis axis) const override
| Returns the computed minimum value of this dataseries along the given axis.
virtual double | maximum (Axis axis) const override
| Returns the computed maximum value of this dataseries along the given axis.
void | setXAbscis (double XMinimum, double deltaX)
| Sets the minimum and delta for the X-axis.
double | XMinimum () const
| Returns the minimum value of the X-axis.
double | deltaX () const
| Returns the delta value of the X-axis.
void | setYAbscis (double YMinimum, double deltaY)
| Sets the minimum and delta for the Y-axis.
double | YMinimum () const
| Returns the minimum value of the Y-axis.
double | deltaY () const
| Returns the delta value of the Y-axis.
Public Member Functions inherited from Wt::Chart::WAbstractGridData
| WAbstractGridData (std::shared_ptr< WAbstractItemModel > model)
| Constructor.
void | setType (Series3DType type)
| Sets the type of representation that will be used for the data.
virtual Series3DType | type () const
| Returns the type of representation that will be used for the data.
void | setSurfaceMeshEnabled (bool enabled=true)
| Enables or disables a mesh for when a surface is drawn.
bool | isSurfaceMeshEnabled ()
| Returns whether the surface-mesh is enabled for this dataseries.
void | setBarWidth (double xWidth, double yWidth)
| Sets the bar-width.
double | barWidthX ()
| Returns the bar-width in the X-axis direction.
double | barWidthY ()
| Returns the bar-width in the Y-axis direction.
void | setPen (const WPen &pen)
| Sets the WPen that is used for drawing the mesh.
WPen | pen () const
| Returns the pen that is used for drawing the mesh.
std::vector< WSurfaceSelection > | pickSurface (int x, int y) const
| Find all points on the surface that are projected to the given pixel.
WBarSelection | pickBar (int x, int y) const
| Return the bar that is closest to the look point at the given pixel.
void | setIsoLevels (const std::vector< double > &isoLevels)
| Set isoline levels.
const std::vector< double > & | isoLevels () const
| Get all of the isoline levels.
void | setIsoColorMap (const std::shared_ptr< WAbstractColorMap > &colormap)
| Set the color map for the isolines.
std::shared_ptr< WAbstractColorMap > | isoColorMap () const
| Get the color map for the isolines.
void | setClippingMin (Axis axis, float v)
| Set the value below which the data series will be clipped on the given axis.
float | clippingMin (Axis axis) const
| Gets the value below which the data series will be clipped on the given axis.
JSlot & | changeClippingMin (Axis axis)
| JSlot to change the value below which the data series will be clipped on the given axis.
void | setClippingMax (Axis axis, float v)
| Set the value above which the data series will be clipped on the given axis.
float | clippingMax (Axis axis) const
| Gets the value above which the data series will be clipped on the given axis.
JSlot & | changeClippingMax (Axis axis)
| JSlot to change the value above which the data series will be clipped on the given axis.
void | setClippingLinesEnabled (bool clippingLinesEnabled)
| Sets whether clipping lines should be drawn where a surface is clipped.
bool | clippingLinesEnabled () const
| Returns whether clipping lines are enabled.
void | setClippingLinesColor (WColor color)
| Sets the color of the clipping lines.
WColor | clippingLinesColor () const
| Gets the color of the clipping lines.
virtual void | initializeGL () override
| Initialize GL resources.
virtual void | paintGL () const override
| Update the client-side painting function.
virtual void | updateGL () override
| Update GL resources.
virtual void | resizeGL () override
| Act on resize events.
virtual void | deleteAllGLResources () override
| Delete GL resources.
Public Member Functions inherited from Wt::Chart::WAbstractDataSeries3D
| WAbstractDataSeries3D (std::shared_ptr< WAbstractItemModel > model)
| Constructor.
void | setTitle (const WString &name)
| Sets the title of this dataseries.
const WString & | title () const
| Returns the title of this dataseries.
void | setModel (const std::shared_ptr< WAbstractItemModel > &model)
| Sets a model from which the dataseries gets its data.
std::shared_ptr< WAbstractItemModel > | model () const
| Returns a pointer to the model used by this dataseries.
const WCartesian3DChart * | chart () const
| Returns a const pointer to the WCartesian3DChart on which the dataseries is drawn.
void | setPointSize (double size)
| Sets the pointsize for drawing this dataseries.
double | pointSize () const
| Returns the pointsize for drawing this dataseries.
void | setPointSprite (const std::string &image)
| Set the point sprite used for drawing this dataseries.
const std::string & | pointSprite () const
| Returns the point sprite used for drawing this dataseries.
void | setColorMap (const std::shared_ptr< WAbstractColorMap > &colormap)
| Sets the colormap for this dataseries.
const WAbstractColorMap * | colorMap () const
| Returns the colormap used by this dataseries.
void | setColorMapVisible (bool enabled=true)
| Sets whether the colormap that is used should be shown alongside the chart in the form of a legend.
bool | colorMapVisible () const
| Returns whether the colormap is shown alongside the chart in the form of a legend.
void | setColorMapSide (Side side)
| Sets whether the colormap is shown on the left or right.
Side | colorMapSide () const
| Returns on which side the colormap is shown.
void | setLegendEnabled (bool enabled=true)
| Sets whether this dataseries is included in the chart-legend.
bool | isLegendEnabled () const
| Returns whether this dataseries is included in the chart-legend.
void | setHidden (bool enabled=true)
| Sets if this dataseries is hidden.
bool | isHidden () const
| Returns if this dataseries is hidden.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual const std::string | id () const
| Returns the (unique) identifier for this object.
virtual void | setObjectName (const std::string &name)
| Sets an object name.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::Chart::WAbstractGridData
Protected Member Functions inherited from Wt::Chart::WAbstractGridData
Protected Member Functions inherited from Wt::Chart::WAbstractDataSeries3D
Protected Member Functions inherited from Wt::WObject
virtual WStatelessSlot * | getStateless (Method method)
| On-demand stateless slot implementation.
Protected Attributes inherited from Wt::Chart::WAbstractGridData
Protected Attributes inherited from Wt::Chart::WAbstractDataSeries3D
Static Protected Attributes inherited from Wt::Chart::WAbstractGridData

## Detailed Description

Class representing grid-based data for on a 3D chart.

General information can be found at WAbstractDataSeries3D. The model for this dataseries does not contain an x- and y-axis. Instead the class derives the x- and y-values from the minimum and delta provided in the constructor. The size of the model determines the size of the grid. The model itself is structured as a table, where every value represents the z-value of a data-point. The corresponding x- and y-values are calculated by adding delta times the row/column-index to the axis-minimum.

## Member Function Documentation

## ◆ deltaX()

double Wt::Chart::WEquidistantGridData::deltaX | ( |  | ) | const

Returns the delta value of the X-axis.

The delta is the interval between subsequent values on the axis.

See also
  setXAbscis()

## ◆ deltaY()

double Wt::Chart::WEquidistantGridData::deltaY | ( |  | ) | const

Returns the delta value of the Y-axis.

The delta is the interval between subsequent values on the axis.

See also
  setYAbscis()

## ◆ maximum()

virtual double Wt::Chart::WEquidistantGridData::maximum | ( | Axis | axis | ) | const
| overridevirtual

Returns the computed maximum value of this dataseries along the given axis.

See also
  minimum()

Implements Wt::Chart::WAbstractGridData.

## ◆ minimum()

virtual double Wt::Chart::WEquidistantGridData::minimum | ( | Axis | axis | ) | const
| overridevirtual

Returns the computed minimum value of this dataseries along the given axis.

See also
  maximum()

Implements Wt::Chart::WAbstractGridData.

## ◆ XMinimum()

double Wt::Chart::WEquidistantGridData::XMinimum | ( |  | ) | const

Returns the minimum value of the X-axis.

See also
  setXAbscis()

## ◆ YMinimum()

double Wt::Chart::WEquidistantGridData::YMinimum | ( |  | ) | const

Returns the minimum value of the Y-axis.

See also
  setYAbscis()